## pypy 7.3.1+dfsg

=== Makefile ===

all: pypy-c cffi_imports

PYPY_EXECUTABLE := $(shell which pypy)

ifeq ($(PYPY_EXECUTABLE),)
RUNINTERP = python
else
RUNINTERP = $(PYPY_EXECUTABLE)
endif

URAM := $(shell $(RUNINTERP) -c "import sys; print 4.5 if sys.maxint>1<<32 else 2.5")

.PHONY: pypy-c cffi_imports

pypy-c:
	@echo
	@echo "===================================================================="
ifeq ($(PYPY_EXECUTABLE),)
	@echo "Building a regular (jitting) version of PyPy, using CPython."
	@echo "This takes around 2 hours and $(URAM) GB of RAM."
	@echo "Note that pre-installing a PyPy binary would reduce this time"
	@echo "and produce basically the same result."
else
	@echo "Building a regular (jitting) version of PyPy, using"
	@echo "$(PYPY_EXECUTABLE) to run the translation itself."
	@echo "This takes up to 1 hour and $(URAM) GB of RAM."
endif
	@echo
	@echo "For more control (e.g. to use multiple CPU cores during part of"
	@echo "the process) you need to run \`\`rpython/bin/rpython'' directly."
	@echo "For more information see \`\`http://pypy.org/download.html''."
	@echo "===================================================================="
	@echo
	@sleep 5
	cd pypy/goal && $(RUNINTERP) ../../rpython/bin/rpython -Ojit targetpypystandalone.py

# Note: the -jN option, or MAKEFLAGS=-jN, are not usable.  They are
# replaced with an opaque --jobserver option by the time this Makefile
# runs.  We cannot get their original value either:
# http://lists.gnu.org/archive/html/help-make/2010-08/msg00106.html

cffi_imports: pypy-c
	PYTHONPATH=. pypy/goal/pypy-c pypy/tool/build_cffi_imports.py || /bin/true

=== debian/changelog ===
pypy (7.3.1+dfsg-3build2) groovy; urgency=medium

  * No change rebuild against new libffi8ubuntu1 ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Aug 2020 12:17:47 +0100

pypy (7.3.1+dfsg-3build1) groovy; urgency=medium

  * No change rebuild against new libffi8ubuntu1 ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Aug 2020 01:24:31 +0100

pypy (7.3.1+dfsg-3) unstable; urgency=medium

  * Support --system-site-packages in virtualenv 20.
  * Use upstream's tool to build cffi modules, directly. It is useable
    stand-alone, these days, and catches failures.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 08 May 2020 12:38:17 -0700

pypy (7.3.1+dfsg-2) unstable; urgency=medium

  * Point to the installed stdlib in the pypy-local sysconfig layout, to
    support virtualenv 20.
  * Build out autopkgtests a little. Test: cffi lib importability, local
    package installation, virtualenvs, byte-compilation.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 20 Apr 2020 15:35:45 -0700

pypy (7.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release, upload to unstable.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 10 Apr 2020 12:33:52 -0700

pypy (7.3.1~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC, upload to experimental
  * Update copyright.
  * Bump Standards-Version to 4.5.0, no changes needed.
  * Refresh patches.
  * Update build-cffi-modules to use upstream's new library location.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 09 Apr 2020 16:06:11 -0700

pypy (7.3.0+dfsg-3) unstable; urgency=medium

  * Patch: Force s390x port to target z10 by default.
  * Patch: Build Sphinx docs with Python 3. This requires disabling autodoc
    and other custom extensions.
  * Execute python2 (instead of python) during the build.
  * We don't need python-docutils, any more.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 24 Mar 2020 19:16:40 -0700

pypy (7.3.0+dfsg-2) unstable; urgency=medium

  * Build-Depend on python2 instead of python.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 14 Jan 2020 07:58:52 +0200

pypy (7.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Drop patch arm64-gcc-bug, superseded upstream.
  * Update copyright.
  * Build with pypy on arm64, now that we've bootstrapped the JIT.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 24 Dec 2019 08:33:03 +0200

pypy (7.2.0+dfsg-1) unstable; urgency=medium

  * New upstream final release.
  * Upload to unstable.
  * Enable JIT and continuation module on arm64.
  * Refresh patches.
  * Drop patch fix-revdb, superseded upstream.
  * Patch arm64-gcc-bug: Avoid a GCC bug in the new arm64 JIT.
  * Bump Standards-Version to 4.4.1, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 02 Nov 2019 11:37:59 -0700

pypy (7.2.0~rc0+dfsg-1) experimental; urgency=medium

  * New upstream RC, upload to experimental.
  * Drop Pre-Depends dpkg (>= 1.15.6~). xz is always supported, these days.
  * Move more translation logic into debian/scripts/translate.sh
  * Refresh patches.
  * Drop patch version-7.1.1, superseded upstream.
  * Refresh copyright.
  * Bump Standards-Version to 4.4.0, no changes needed.
  * Patch fix-revdb: Make RevDB build.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 03 Oct 2019 14:50:09 +0300

=== debian/control ===
Source: pypy
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Stefano Rivera <stefanor@debian.org>
Build-Depends:
 debhelper (>= 9.20141010~),
 dh-exec,
 dpkg-dev (>= 1.17.14~),
 libbz2-dev,
 libexpat1-dev,
 libffi-dev,
 libgdbm-dev,
 libncurses-dev,
 libsqlite3-dev,
 libssl-dev,
 netbase,
 pkg-config,
 procps,
 pypy [any-amd64 any-i386 arm64 armhf ppc64 ppc64el s390x] <!stage1>,
 python-pycparser,
 python2,
 python2.7-dev,
 python3-sphinx (>= 1.0.7+dfsg),
 tcl-dev,
 tk-dev,
 valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
 zlib1g-dev
Build-Depends-Indep: graphviz
Standards-Version: 4.5.0
Homepage: http://pypy.org/
Vcs-Git: https://salsa.debian.org/debian/pypy.git
Vcs-Browser: https://salsa.debian.org/debian/pypy
Rules-Requires-Root: no

Package: pypy
Architecture: any
Depends: pypy-lib (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks:
 pypy-backports.functools-lru-cache (<< 1.5-3~),
 pypy-dev (<< ${source:Version})
Provides: ${pypy-abi}
Suggests: pypy-doc, pypy-tk (= ${binary:Version})
Description: fast alternative implementation of Python - PyPy interpreter
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7). It has several advantages and distinct features:
  * Speed: thanks to its Just-in-Time compiler (on x86), Python programs often
    run faster on PyPy.
  * Memory usage: large, memory-hungry Python programs might end up taking less
    space than they do in CPython.
  * Compatibility: PyPy is highly compatible with existing Python code.
    It supports ctypes and can run popular Python libraries like twisted and
    django.
  * Stackless: PyPy supports stackless mode on most platforms, providing
    micro-threads for massive concurrency.
 .
 This package contains the PyPy interpreter.

Package: pypy-tk
Architecture: any
Depends: pypy (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Replaces: pypy-lib (<< 2.2)
Description: Tkinter module for PyPy (an alternative Python interpreter)
 A module for writing portable GUI applications with PyPy using Tk.
 Also known as Tkinter.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-lib
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Provides: ${cffi:Provides}
Description: standard library for PyPy (an alternative Python interpreter)
 The PyPy standard library. This is a combination of modules, copied directly
 from cpython, modified cpython modules, and modules entirely re-implemented
 (usually in pure Python, where they are C extensions in cpython).
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-lib-testsuite
Architecture: all
Depends: pypy, pypy-lib (>= ${source:Version}), ${misc:Depends}
Replaces: pypy-lib (<< 2.2)
Description: standard library test suite for PyPy (an alternative Python interpreter)
 The complete test suite for the PyPy standard library.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python2-doc
Description: developer Documentation for PyPy (an alternative Python interpreter)
 The Developer documentation for PyPy. This mostly covers the internals of
 PyPy, and development of PyPy itself.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-dev
Architecture: all
Depends: pypy (>= ${source:Version}), ${misc:Depends}
Provides: libpypy-dev
Description: header files for PyPy (an alternative Python interpreter)
 Header files for compiling cpython C extension modules for use with PyPy.
 Note that pure Python modules will probably perform better.
 .
 PyPy supports a subset of cpython's C API through its CPyExt subsystem.
 .
 Also included is PyPy.h, for embedding the PyPy interpreter.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

=== debian/rules ===
#!/usr/bin/make -f

# Take advantage of PyPy if it's installed
PYTHON=$(shell command -v pypy > /dev/null && echo pypy || echo python2.7)

# PyPy doesn't harden well, and handles opt and debug itself
BUILDFLAGS_ENV := DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-fortify
BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O0 -O1 -O2 -O3 -Os -Ofast -g"
export CFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
export LDFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

# Our multiarch patch expects DEB_HOST_MULTIARCH
include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:
	# This rule left intentionally empty

override_dh_auto_build-arch: pypy/goal/pypy-c
	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs

	# Build cffi modules
	pypy/goal/pypy-c lib_pypy/tools/build_cffi_imports.py
	debian/scripts/multiarch-extensions.sh

override_dh_auto_build-indep:
	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs

pypy/goal/pypy-c:
	debian/scripts/translate.sh --python $(PYTHON)

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch: export TMPDIR = $(CURDIR)/build-tests-tmp
override_dh_auto_test-arch: export HOME = $(TMPDIR)
override_dh_auto_test-arch:
	rm -rf $(TMPDIR) build-tests
	mkdir $(TMPDIR) build-tests
	# Test failures currently ignored
	PYTHONPATH=. $(PYTHON) -u testrunner/runner.py \
	                       --logfile=build-tests/pytest-A.log \
	                       --config=pypy/pytest-A.cfg \
	                       --root=pypy || true
	TERM=$${TERM:-dumb} $(PYTHON) -u pypy/test_all.py \
	          --pypy=pypy/goal/pypy-c \
	          --resultlog=build-tests/lib-python.log \
	          lib-python || true
	pypy/goal/pypy-c -u pypy/test_all.py \
	       --resultlog=build-tests/pypy-c.log \
	       pypy/module/pypyjit/test_pypy_c || true
endif

override_dh_auto_install:
	debian/scripts/gen-backend-versions.py

override_dh_fixperms-arch:
	debian/scripts/cleanup-lib.sh pypy-lib
	find debian/pypy-tk \( -name '*.pyc' -o -name '__pycache__' \) -delete
	# Fix interpreters
	find debian/pypy-tk \
	     -name '*.py' -print0 \
	     | xargs -0 sed -i -e '1s|^#!.*python.*|#!/usr/bin/pypy|'
	dh_fixperms -a

override_dh_fixperms-indep:
	debian/scripts/cleanup-lib.sh pypy-lib-testsuite
	dh_fixperms -i

override_dh_sphinxdoc-arch:
	# dh_sphinxdoc doesn't fail silently when there are no docs

override_dh_compress:
	dh_compress -X.inv -X.txt

override_dh_installdeb:
	set -e; for maintscript in preinst postinst prerm; do \
		sed -e 's/#VERSION#/$(VER)/g' \
		    -e 's/#ARCH#/$(shell dpkg-architecture -qDEB_HOST_ARCH)/g' \
		    debian/pypy.$$maintscript.in > debian/pypy.$$maintscript; \
	done
	dh_installdeb

HG_REPO ?= https://bitbucket.org/pypy/pypy
REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p' | sed -e 's/~//')
get-packaged-orig-source:
	@echo "You can build this from a local repo by supplying the HG_REPO variable"
	rm -rf pypy-$(VER).orig
	hg clone $(HG_REPO) pypy-$(VER).orig
ifeq (,$(REV))
	cd pypy-$(VER).orig && hg up -r release-pypy2.7-v$(VER)
else
	cd pypy-$(VER).orig && hg up -r $(REV)
endif
	rm -rf pypy-$(VER).orig/.hg*
	rm pypy-$(VER).orig/lib-python/2.7/distutils/command/*.exe
	rm -rf pypy-$(VER).orig/lib-python/2.7/ensurepip/_bundled/
	tar -cJ --owner root --group root --mode a+rX \
	    -f pypy_$(VER)+dfsg.orig.tar.xz pypy-$(VER).orig
	rm -rf pypy-$(VER).orig

## pypy 7.3.3%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: pypy
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Stefano Rivera <stefanor@debian.org>
+Maintainer: Stefano Rivera <stefanor@debian.org>
 Build-Depends:
  debhelper (>= 9.20141010~),
  dh-exec,
@@ -28,14 +27,15 @@
  zlib1g-dev
 Build-Depends-Indep: graphviz
 Standards-Version: 4.5.0
-Homepage: http://pypy.org/
+Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy
 Rules-Requires-Root: no
 
 Package: pypy
 Architecture: any
-Depends: pypy-lib (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: pypy-lib (= ${binary:Version}), ${shlibs:Pre-Depends}
+Depends: ${misc:Depends}
 Breaks:
  pypy-backports.functools-lru-cache (<< 1.5-3~),
  pypy-dev (<< ${source:Version})

## pypy 7.3.3+dfsg

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,9 @@
 RUNINTERP = $(PYPY_EXECUTABLE)
 endif
 
-URAM := $(shell $(RUNINTERP) -c "import sys; print 4.5 if sys.maxint>1<<32 else 2.5")
+URAM := $(shell $(RUNINTERP) -c "import sys; print(4.5 if sys.maxint>1<<32 else 2.5)")
+
+JOBS=$(subst -j,--make-jobs ,$(filter -j%, $(MAKEFLAGS)))
 
 .PHONY: pypy-c cffi_imports
 
@@ -33,12 +35,7 @@
 	@echo "===================================================================="
 	@echo
 	@sleep 5
-	cd pypy/goal && $(RUNINTERP) ../../rpython/bin/rpython -Ojit targetpypystandalone.py
-
-# Note: the -jN option, or MAKEFLAGS=-jN, are not usable.  They are
-# replaced with an opaque --jobserver option by the time this Makefile
-# runs.  We cannot get their original value either:
-# http://lists.gnu.org/archive/html/help-make/2010-08/msg00106.html
+	cd pypy/goal && $(RUNINTERP) ../../rpython/bin/rpython $(JOBS) -Ojit targetpypystandalone.py
 
 cffi_imports: pypy-c
-	PYTHONPATH=. pypy/goal/pypy-c pypy/tool/build_cffi_imports.py || /bin/true
+	PYTHONPATH=. pypy/goal/pypy-c lib_pypy/pypy_tools/build_cffi_imports.py

=== debian/changelog ===
pypy (7.3.3+dfsg-2) unstable; urgency=medium

  * Move pypy dependencies to Pre-Depends, as the pypy binary is used in
    package maintainer scripts. (Closes: #987213)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 02 May 2021 10:44:17 -0400

pypy (7.3.3+dfsg-1) unstable; urgency=medium

  * New upstream release (identical to RC1).
  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 21 Nov 2020 09:14:19 -0800

pypy (7.3.3~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC.
    - Upload to experimental.
  * Refresh patches.
  * Update copyright.
  * Build pypy using pypy on ppc64 & ppc64el again.
  * Drop patch xdg-gvfs-open. Superseded upstream in 2.3 :P
  * Drop patch test_termios. No longer needed.
  * Drop patches superseded upstream: ppc64-jit-regression, python2-binary,
    test-certificates, test-tls_1.0, test_ssl-tls-1.0.
  * Carry over atomic-pyc-rename and bdist-wininst-notfound from Debian's
    python2.7 package.
  * Update Homepage.
  * Add UpstreamMetadata.
  * Point watch URL at downloads.python.org, bitbucket is no longer used.
  * Fix some warnings in our fibc test package.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 12 Nov 2020 16:26:53 -0800

pypy (7.3.2+dfsg-2) unstable; urgency=medium

  * Patch: Fix JIT breakage on ppc64.
  * Re-bootstrap ppc64 & ppc64el from cpython.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 26 Sep 2020 11:54:08 -0700

pypy (7.3.2+dfsg-1) unstable; urgency=medium

  * New upstream release, upload to unstable.
  * Drop pypy2.7-v7.x-updates patch, superseded upstream.
  * Patch: Ignore fcntl test lease failures known to occur on tmpfs on older
    kernels (e.g. current buildds).
  * Strip rpython/rlib/test/loadtest/loadtest*.dll from the source package.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 25 Sep 2020 12:19:52 -0700

pypy (7.3.2~rc2+dfsg-1) experimental; urgency=medium

  * New upstream RC.
  * Upload to experimental.
  * Refresh patches.
  * Patch: Update to the current state of the release branch.
  * Patch: Disable sphinx-affiliates search, not yet available in Debian.
  * Update copyright.
  * Update the location of build_cffi_imports.
  * Update a dist-packages test in the distutils-install-layout patch.
  * Patch: Point some unit tests at python2, as /usr/bin/python doesn't exist.
  * Patch: Update SSL certificates in unit tests to RSA & DH 3k with SHA-2.
  * Reorganize patches and prefix their commit messages with a category.
  * Patches: Avoid explicit TLS 1.0 connections in tests.
  * Patch: Ignore InvalidTerminal exception in test_readline under TERM=dumb.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 22 Sep 2020 12:29:57 -0700

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 
 	# Build cffi modules
-	pypy/goal/pypy-c lib_pypy/tools/build_cffi_imports.py
+	pypy/goal/pypy-c lib_pypy/pypy_tools/build_cffi_imports.py
 	debian/scripts/multiarch-extensions.sh
 
 override_dh_auto_build-indep:
@@ -73,6 +73,10 @@
 override_dh_compress:
 	dh_compress -X.inv -X.txt
 
+override_dh_shlibdeps-arch:
+	dh_shlibdeps --package=pypy -- -dPre-Depends
+	dh_shlibdeps --arch --remaining-packages
+
 override_dh_installdeb:
 	set -e; for maintscript in preinst postinst prerm; do \
 		sed -e 's/#VERSION#/$(VER)/g' \
@@ -95,6 +99,7 @@
 endif
 	rm -rf pypy-$(VER).orig/.hg*
 	rm pypy-$(VER).orig/lib-python/2.7/distutils/command/*.exe
+	rm pypy-$(VER).orig/rpython/rlib/test/loadtest/loadtest*.dll
 	rm -rf pypy-$(VER).orig/lib-python/2.7/ensurepip/_bundled/
 	tar -cJ --owner root --group root --mode a+rX \
 	    -f pypy_$(VER)+dfsg.orig.tar.xz pypy-$(VER).orig

=== debian/tests/control ===
Tests: byte-compilation
Depends: pypy, shunit2

Tests: command-line
Depends: pypy, shunit2
Restrictions: superficial

Tests: pypy-tk
Depends: pypy-tk, shunit2
Restrictions: superficial

Tests: module-install-local
Depends: build-essential, pypy-dev, pypy-setuptools, shunit2
Restrictions: needs-root

Tests: module-install-user
Depends: build-essential, pypy-dev, pypy-setuptools, shunit2

Tests: module-install-virtualenv
Depends: build-essential, pypy-dev, shunit2, virtualenv

=== debian/watch ===
version=3

# To repack, run debian/rules get-packaged-orig-source
opts=dversionmangle=s/\+dfsg// \
	https://downloads.python.org/pypy/pypy2.7-v([0-9.]+)-src.tar.bz2

## pypy 7.3.5+dfsg

=== debian/changelog ===
pypy (7.3.5+dfsg-1) experimental; urgency=medium

  * New upstream point release.
    - Fixes CVE-2021-3426, CVE-2020-8492.
  * Use the bundled pycparser for translation, so that Debian can drop the
    python-pycparser binary package.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 23 May 2021 08:02:48 -0400

pypy (7.3.4+dfsg-2) experimental; urgency=medium

  * Move pypy dependencies to Pre-Depends, as the pypy binary is used in
    package maintainer scripts. (Closes: #987213)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 02 May 2021 10:38:56 -0400

pypy (7.3.4+dfsg-1) experimental; urgency=medium

  * New upstream release (identical to RC2)

 -- Stefano Rivera <stefanor@debian.org>  Mon, 12 Apr 2021 17:04:17 -0400

pypy (7.3.4~rc2+dfsg-1) experimental; urgency=medium

  * New upstream RC.
  * Refresh patches.
  * Drop patch no-sphinx-affiliates, superseded upstream.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 05 Apr 2021 14:06:53 -0700

pypy (7.3.4~rc1+dfsg-1) experimental; urgency=medium

  [ Stefano Rivera ]
  * New upstream RC.
    - Upload to experimental.
  * Drop patch s390x-z10, not needed since 7.3.1 dropped the assert we were
    protecting ourselves from.
  * Update s390x model target: z196 on Debian, zEC12 on Ubuntu < focal, z13 on
    Ubuntu >= focal.
  * Refresh patches.
  * Update copyright.
  * Bump Standards-Version to 4.5.1, no changes needed.
  * Bump watch file version to 4.

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + pypy-doc: Add Multi-Arch: foreign.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 22 Mar 2021 12:36:08 -0700

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,6 @@
  pkg-config,
  procps,
  pypy [any-amd64 any-i386 arm64 armhf ppc64 ppc64el s390x] <!stage1>,
- python-pycparser,
  python2,
  python2.7-dev,
  python3-sphinx (>= 1.0.7+dfsg),
@@ -26,7 +25,7 @@
  valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy
@@ -95,6 +94,7 @@
 Architecture: all
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Suggests: python2-doc
+Multi-Arch: foreign
 Description: developer Documentation for PyPy (an alternative Python interpreter)
  The Developer documentation for PyPy. This mostly covers the internals of
  PyPy, and development of PyPy itself.

## pypy 7.3.9%2Bdfsg

=== debian/tests/control ===
--- 
+++ 
@@ -17,4 +17,12 @@
 Depends: build-essential, pypy-dev, pypy-setuptools, shunit2
 
 Tests: module-install-virtualenv
-Depends: build-essential, pypy-dev, shunit2, virtualenv
+Depends:
+ build-essential,
+ pypy-dev,
+ python2-pip-whl (>= 20.3.4+dfsg-4~),
+ python2-setuptools-whl,
+ python2-wheel-whl,
+ shunit2,
+ virtualenv
+Restrictions: allow-stderr

## pypy 7.3.9+dfsg

=== requirements.txt ===
--only-binary vmprof
# because the win64 build worker get confused whether it is 32 or 64-bit
--no-binary cffi
cffi>=1.4.0

# parse log files in rvmprof tests
vmprof>=0.4.10; 'x86' in platform.machine #skip arm, s390x

# hypothesis is used for test generation on untranslated tests
hypothesis<4.40
enum34>=1.1.2

=== debian/changelog ===
pypy (7.3.9+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Correct the license for osx-roots.diff.
  * Build-Depend on valgrind-if-available, instead of a hardcoded arch list.
  * Synchronise module-install-* autopkgtests with python3 3.10.2-7:
    - Test install destination.
    - Test setuptools develop installations.
    - Test installation via pip (in virtualenvs, we don't have a pypy-pip
      package).

 -- Stefano Rivera <stefanor@debian.org>  Thu, 31 Mar 2022 21:37:17 -0400

pypy (7.3.8+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Upload to unstable
  * Drop RC2 patch, superseded by final release.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 20 Feb 2022 14:18:50 -0400

pypy (7.3.8~rc1+dfsg-2) experimental; urgency=medium

  * Patch: Update to RC2
  * Drop patch cffi-bundled-pycparser, superseded upstream.
  * Update debian copyright.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 11 Feb 2022 08:30:44 -0400

pypy (7.3.8~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC.
    - Upload to experimental.
  * Refresh patches.
  * Drop patch openssl-3.0.0, superseded upstream.
  * PyPy.h was dropped upstream, cffi should be used for embedding PyPy.
  * Patch cffi-bundled-pycparser: Fix a cffi regression.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 30 Jan 2022 17:54:29 -0400

pypy (7.3.6+dfsg-3) unstable; urgency=medium

  * Re-instate pypy-lib.prerm, duplicating the pypyclean from pypy.prerm to
    clean up pypy-lib .pyc files before upgrading it. (See: #1004369)
    - Add some one-off cleanup for 7.3.6+dfsg-2.
  * Exclude make_ssl_data.py from pypy-lib, this a developer tool, written in
    Python 3 syntax. (Closes: #1004369)

 -- Stefano Rivera <stefanor@debian.org>  Thu, 27 Jan 2022 07:43:49 -0400

pypy (7.3.6+dfsg-2) unstable; urgency=medium

  * virtualenv autopkgtest: Depend on python2-pip-whl, python2-setuptools-whl,
    and python2-wheel-whl. (Closes: #1003573)
  * Patch: OpenSSL 3.0.0 support.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 23 Jan 2022 08:50:00 -0400

pypy (7.3.6+dfsg-1) unstable; urgency=medium

  * New upstream release (same as RC2).
  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 17 Oct 2021 10:23:26 -0700

pypy (7.3.6~rc2+dfsg-1) experimental; urgency=medium

  * New upstream RC.
  * Refresh patches.
  * Update copyright.
  * Bump Standards-Version to 4.6.0, no changes needed.
  * Handle RCs correctly in get-packaged-orig-source.
  * Drop patch ppc-jit-backend, superseded upstream.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 06 Oct 2021 20:56:34 -0700

pypy (7.3.5+dfsg-3) unstable; urgency=medium

  * Fix PPC JIT backend code generation. (Closes: #994265)

 -- Stefano Rivera <stefanor@debian.org>  Sat, 25 Sep 2021 09:12:52 -0700

pypy (7.3.5+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 17 Aug 2021 22:09:48 -0400

=== debian/control ===
--- 
+++ 
@@ -22,10 +22,10 @@
  python3-sphinx (>= 1.0.7+dfsg),
  tcl-dev,
  tk-dev,
- valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
+ valgrind-if-available,
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy
@@ -112,7 +112,5 @@
  .
  PyPy supports a subset of cpython's C API through its CPyExt subsystem.
  .
- Also included is PyPy.h, for embedding the PyPy interpreter.
- .
  PyPy is a fast, compliant alternative implementation of the Python language
  (2.7).

=== debian/rules ===
--- 
+++ 
@@ -78,29 +78,29 @@
 	dh_shlibdeps --arch --remaining-packages
 
 override_dh_installdeb:
-	set -e; for maintscript in preinst postinst prerm; do \
-		sed -e 's/#VERSION#/$(VER)/g' \
-		    -e 's/#ARCH#/$(shell dpkg-architecture -qDEB_HOST_ARCH)/g' \
-		    debian/pypy.$$maintscript.in > debian/pypy.$$maintscript; \
-	done
+	debian/scripts/maintscript.sh pypy.preinst
+	debian/scripts/maintscript.sh pypy.postinst
+	debian/scripts/maintscript.sh pypy.prerm
+	debian/scripts/maintscript.sh pypy-lib.prerm
 	dh_installdeb
 
 HG_REPO ?= https://bitbucket.org/pypy/pypy
-REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
-VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p' | sed -e 's/~//')
+REV = $(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
+DVER = $(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
+UVER = $(shell echo $(DVER) | sed -e 's/~//')
 get-packaged-orig-source:
 	@echo "You can build this from a local repo by supplying the HG_REPO variable"
-	rm -rf pypy-$(VER).orig
-	hg clone $(HG_REPO) pypy-$(VER).orig
+	rm -rf pypy-$(DVER).orig
+	hg clone $(HG_REPO) pypy-$(DVER).orig
 ifeq (,$(REV))
-	cd pypy-$(VER).orig && hg up -r release-pypy2.7-v$(VER)
+	cd pypy-$(DVER).orig && hg up -r release-pypy2.7-v$(UVER)
 else
-	cd pypy-$(VER).orig && hg up -r $(REV)
+	cd pypy-$(DVER).orig && hg up -r $(REV)
 endif
-	rm -rf pypy-$(VER).orig/.hg*
-	rm pypy-$(VER).orig/lib-python/2.7/distutils/command/*.exe
-	rm pypy-$(VER).orig/rpython/rlib/test/loadtest/loadtest*.dll
-	rm -rf pypy-$(VER).orig/lib-python/2.7/ensurepip/_bundled/
+	rm -rf pypy-$(DVER).orig/.hg*
+	rm pypy-$(DVER).orig/lib-python/2.7/distutils/command/*.exe
+	rm pypy-$(DVER).orig/rpython/rlib/test/loadtest/loadtest*.dll
+	rm -rf pypy-$(DVER).orig/lib-python/2.7/ensurepip/_bundled/
 	tar -cJ --owner root --group root --mode a+rX \
-	    -f pypy_$(VER)+dfsg.orig.tar.xz pypy-$(VER).orig
-	rm -rf pypy-$(VER).orig
+	    -f pypy_$(DVER)+dfsg.orig.tar.xz pypy-$(DVER).orig
+	rm -rf pypy-$(DVER).orig

=== debian/watch ===
--- 
+++ 
@@ -1,4 +1,4 @@
-version=3
+version=4
 
 # To repack, run debian/rules get-packaged-orig-source
 opts=dversionmangle=s/\+dfsg// \
